Package org.apache.storm.topology

# Class BaseStatefulBoltExecutor

java.lang.Object
org.apache.storm.topology.BaseStatefulBoltExecutor

All Implemented Interfaces:
  `Serializable`, `IBolt`, `IComponent`, `IRichBolt`

Direct Known Subclasses:
  `CheckpointTupleForwarder`, `StatefulBoltExecutor`

public abstract class BaseStatefulBoltExecutor extends Object implements IRichBolt
Base class that abstracts the common logic for executing bolts in a stateful topology.

See Also:
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected static class`
  `BaseStatefulBoltExecutor.AnchoringOutputCollector`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected OutputCollector`
  `collector`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseStatefulBoltExecutor()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `declareCheckpointStream(OutputFieldsDeclarer declarer)`
  `void`
  `execute(Tuple input)`
  Process a single tuple of input.
  `protected abstract void`
  `handleCheckpoint(Tuple checkpointTuple, CheckPointState.Action action, long txid)`
  Sub-classes can implement the logic for handling checkpoint tuple.
  `protected abstract void`
  `handleTuple(Tuple input)`
  Sub-classes can implement the logic for handling the tuple.
  `protected void`
  `init(TopologyContext context, OutputCollector collector)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.storm.task.IBolt

  `cleanup, prepare`

  ### Methods inherited from interface org.apache.storm.topology.IComponent

  `declareOutputFields, getComponentConfiguration`

- ## Field Details

  - ### collector

    protected OutputCollector collector

- ## Constructor Details

  - ### BaseStatefulBoltExecutor

    public BaseStatefulBoltExecutor()

- ## Method Details

  - ### init

    protected void init(TopologyContext context, OutputCollector collector)

  - ### execute

    public void execute(Tuple input)
    Description copied from interface: `IBolt`
    Process a single tuple of input. The Tuple object contains metadata on it about which component/stream/task it came from. The values of the Tuple can be accessed using Tuple#getValue. The IBolt does not have to process the Tuple immediately. It is perfectly fine to hang onto a tuple and process it later (for instance, to do an aggregation or join).

    Tuples should be emitted using the OutputCollector provided through the prepare method. It is required that all input tuples are acked or failed at some point using the OutputCollector. Otherwise, Storm will be unable to determine when tuples coming off the spouts have been completed.

    For the common case of acking an input tuple at the end of the execute method, see IBasicBolt which automates this.

    Specified by:
      `execute` in interface `IBolt`
    Parameters:
      `input` - The input tuple to be processed.

  - ### declareCheckpointStream

    protected void declareCheckpointStream(OutputFieldsDeclarer declarer)

  - ### handleTuple

    protected abstract void handleTuple(Tuple input)
    Sub-classes can implement the logic for handling the tuple.
    Parameters:
      `input` - the input tuple

  - ### handleCheckpoint

    protected abstract void handleCheckpoint(Tuple checkpointTuple, CheckPointState.Action action, long txid)
    Sub-classes can implement the logic for handling checkpoint tuple.
    Parameters:
      `checkpointTuple` - the checkpoint tuple
      `action` - the action (prepare, commit, rollback or initstate)
      `txid` - the transaction id.